//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3EF8AD150038.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EF8AD150038.cm

//## begin module%3EF8AD150038.cp preserve=no
//## end module%3EF8AD150038.cp

//## Module: HelpComposite%3EF8AD150038; Package body
//## Subsystem: XSUser::Help%3EF8A6EC00F8
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUser/Help/HelpComposite.cxx

//## begin module%3EF8AD150038.additionalIncludes preserve=no
//## end module%3EF8AD150038.additionalIncludes

//## begin module%3EF8AD150038.includes preserve=yes
#include "XSstreams.h"
//## end module%3EF8AD150038.includes

// HelpComposite
#include <XSUser/Help/HelpComposite.h>
//## begin module%3EF8AD150038.declarations preserve=no
//## end module%3EF8AD150038.declarations

//## begin module%3EF8AD150038.additionalDeclarations preserve=yes
#include <iomanip>
#include <ios>
#include <iostream>
//## end module%3EF8AD150038.additionalDeclarations


// Class HelpComposite 

HelpComposite::HelpComposite(const HelpComposite &right)
  //## begin HelpComposite::HelpComposite%3EF8AA2703AE_copy.hasinit preserve=yes
  : Help(right),
    m_mapParams(right.m_mapParams)
  //## end HelpComposite::HelpComposite%3EF8AA2703AE_copy.hasinit
  //## begin HelpComposite::HelpComposite%3EF8AA2703AE_copy.initialization preserve=yes
  //## end HelpComposite::HelpComposite%3EF8AA2703AE_copy.initialization
{
  //## begin HelpComposite::HelpComposite%3EF8AA2703AE_copy.body preserve=yes
  //## end HelpComposite::HelpComposite%3EF8AA2703AE_copy.body
}

HelpComposite::HelpComposite (const string& cmd, const string& path, Help::DocTypes docType, bool online)
  //## begin HelpComposite::HelpComposite%3EF8AFBF004C.hasinit preserve=yes
  : Help(cmd, path, docType, true, online)              
  //## end HelpComposite::HelpComposite%3EF8AFBF004C.hasinit
  //## begin HelpComposite::HelpComposite%3EF8AFBF004C.initialization preserve=yes
  //## end HelpComposite::HelpComposite%3EF8AFBF004C.initialization
{
  //## begin HelpComposite::HelpComposite%3EF8AFBF004C.body preserve=yes
  //## end HelpComposite::HelpComposite%3EF8AFBF004C.body
}

HelpComposite::HelpComposite (const Help& right)
  //## begin HelpComposite::HelpComposite%3EF8AFFF0192.hasinit preserve=yes
  : Help(right)
  //## end HelpComposite::HelpComposite%3EF8AFFF0192.hasinit
  //## begin HelpComposite::HelpComposite%3EF8AFFF0192.initialization preserve=yes
  //## end HelpComposite::HelpComposite%3EF8AFFF0192.initialization
{
  //## begin HelpComposite::HelpComposite%3EF8AFFF0192.body preserve=yes
    isComposite(true);
  //## end HelpComposite::HelpComposite%3EF8AFFF0192.body
}


HelpComposite::~HelpComposite()
{
  //## begin HelpComposite::~HelpComposite%3EF8AA2703AE_dest.body preserve=yes
  std::map<string,Help*>::iterator itHelp = m_mapParams.begin();
  std::map<string,Help*>::iterator itEnd = m_mapParams.end();
  while (itHelp != itEnd)
  {
     delete itHelp->second;
     ++itHelp;
  }
  //## end HelpComposite::~HelpComposite%3EF8AA2703AE_dest.body
}


HelpComposite & HelpComposite::operator=(const HelpComposite &right)
{
  //## begin HelpComposite::operator=%3EF8AA2703AE_assign.body preserve=yes
    return *this;
  //## end HelpComposite::operator=%3EF8AA2703AE_assign.body
}



//## Other Operations (implementation)
void HelpComposite::addOrUpdateComponent (const string& cmd, Help* help)
{
  //## begin HelpComposite::addOrUpdateComponent%3EF8AF6F00D2.body preserve=yes
    std::map<string,Help*>::iterator p = m_mapParams.find(cmd);
    if ( p != m_mapParams.end())
    {
        delete p->second;
        m_mapParams.erase(p);
    }
    m_mapParams.insert(std::map<string,Help*>::value_type(cmd,help));
  //## end HelpComposite::addOrUpdateComponent%3EF8AF6F00D2.body
}

void HelpComposite::execute (const StringArray& strParams, int index) const
{
  //## begin HelpComposite::execute%3F2144000360.body preserve=yes
    using namespace std;

    int size = strParams.size();

    if(index == size - 1)
    {
	Help::execute(strParams, index);
    }
    else 
    {
	Help* match;

	if(mapParams(strParams[++index], match) != 0)
        {
	    match->execute(strParams, index);
        }
	else 
        { 
            if ( index >= 1 && strParams[index][0] != '?')
            {
	        tcout << "\nInvalid help option."; 
            }
            tcout << " Valid options are:\n";
	    int count = 0;

	    std::map<string, Help*>::const_iterator 
		i_mapParamsBegin = m_mapParams.begin(),
		i_mapParamsEnd   = m_mapParams.end();
	    
	    while(i_mapParamsBegin != i_mapParamsEnd) 
            {
		if(!(count % 3)) tcout << std::endl;

		tcout << setiosflags(ios::left) << setw(20) << i_mapParamsBegin->first.c_str();

		++count;
		++i_mapParamsBegin;
	    }
	    tcout << std::endl << std::endl;
            tcout << "  To get help for a particular model component, enter \n\"help model <comp name>\"."
                << " (To view list of model components, \nenter \"model\".)" 
                << std::endl << std::endl; 
	}
    }        
  //## end HelpComposite::execute%3F2144000360.body
}

bool HelpComposite::mapParams (const string& cmd, Help*& match, bool exactOnly) const
{
  //## begin HelpComposite::mapParams%3F21462F01EC.body preserve=yes
    std::map<string, Help*>::const_iterator itr = m_mapParams.lower_bound(cmd);
    std::map<string, Help*>::const_iterator itrEnd = m_mapParams.end();
    
    if  (itr != itrEnd)     
    {
       if (exactOnly)
       {
          if (itr->first == cmd)
          {
             match = itr->second;
             return true;
          }
       }
       else   // allow abbreviated commands
       {
          if (itr->first.find(cmd) == 0) 
          {
	      match = itr->second;
	      return true;
          }
       }
    }
    return false;
  //## end HelpComposite::mapParams%3F21462F01EC.body
}

// Additional Declarations
  //## begin HelpComposite%3EF8AA2703AE.declarations preserve=yes
  //## end HelpComposite%3EF8AA2703AE.declarations

//## begin module%3EF8AD150038.epilog preserve=yes
//## end module%3EF8AD150038.epilog
